﻿using PIbd_24_EredavkinRA_BusBusiness.Entities;
using PIbd_24_EredavkinRA_BusBusiness.Entities.Enums;
using PIbd_24_EredavkinRA_BusBusiness.Repositories;


namespace PIbd_24_EredavkinRA_BusBusiness.Forms;

public partial class FormStaff : Form
{
    private readonly IStaffRepositories _staffRepository;
    private int? _staffId;
    public int Id
    {
        set
        {
            try
            {
                var staff = _staffRepository.ReadStaffByID(value);
                if (staff == null)
                {
                    throw new
                    InvalidDataException(nameof(staff));
                }
                textBoxFirstName.Text = staff.FirstName;
                textBoxLastName.Text = staff.LastName;
                comboBoxPost.SelectedItem = staff.EmployeePost;
                _staffId = value;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при получении данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
        }
    }


    public FormStaff(IStaffRepositories staffRepositories)
    {
        InitializeComponent();
        _staffRepository = staffRepositories ??
            throw new ArgumentNullException(nameof(staffRepositories));
        comboBoxPost.DataSource = Enum.GetValues(typeof(EmployeePost));
    }

    private void buttoтSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (string.IsNullOrWhiteSpace(textBoxFirstName.Text) ||string.IsNullOrWhiteSpace(textBoxLastName.Text) || comboBoxPost.SelectedIndex < 1)
            {
                throw new Exception("Имеются незаполненныеполя");
            }
            if (_staffId.HasValue)
            {
                _staffRepository.UpdateStaff(CreateStaff(_staffId.Value));
            }
            else
            {
                _staffRepository.CreateStaff(CreateStaff(0));
            }
            Close();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "Ошибка при сохранении",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void buttonCancel_Click(object sender, EventArgs e) => Close();
    private Staff CreateStaff(int id) => Staff.CreatEntity(id, 
                                                           textBoxFirstName.Text, 
                                                           textBoxLastName.Text, 
                                                           (EmployeePost)comboBoxPost.SelectedItem!);




}
